#ifndef TCPSERVER_H
#define TCPSERVER_H

//
// simple tcp server class
// 
// Markus Geisler <geisler@primusnetz.de>
//

#include "TCPserverThread.h"
#include "FeedbackBuffer.h"
#include "config.h"

class TCPserver
{
	private:

	int port;
	char *interface;
	int mysocket;
	struct sockaddr_in client_addr;
	struct sockaddr_in server_addr;
	socklen_t client_len;
	TCPserverThread *myThreads[MAXTHREADS];
	TCPserverThread *nextThread;
	// Thread running matrix (thread-id,running-status)
	struct matrix
	{
		TCPserverThread *pointer;
		int status;
		pthread_t id;
		char *addr;
	} ThreadMatrix[MAXTHREADS];

	int running;
	int notrunning;

	FeedbackBuffer *myFeedbackBuffer;

	public:

	TCPserver(int,char*);
	~TCPserver();

        int connect();
	int disconnect();
	char *wait();
	void *wrapper(void *);
	TCPserverThread *newThread(int,pthread_mutex_t *,char *);
	void checkThreadMatrix();
	static void *cyclicMatrixCheck(void *);
};

#endif
