#ifndef TCPSERVERTHREAD_H
#define TCPSERVERTHREAD_H

//
// simple tcp server thread class
// 
// Markus Geisler <geisler@primusnetz.de>
//

#include "FeedbackBuffer.h"
#include "config.h"

class TCPserverThread
{
	private:

	int mysocket;
	pthread_mutex_t *mymutex;
	int status;
	int bufferpos;
	char *inputBuffer;
	int myId;
	FeedbackBuffer *myFeedbackBuffer;

	public:

	TCPserverThread();
	~TCPserverThread();

	void setSocket(int);
	void setMutex(pthread_mutex_t *);
	void setId(int);
	void setFeedbackBuffer(FeedbackBuffer *);
	static void *wrapper(void *);
        void run();
        int isRunning();
	char *getData();
};

#endif 
